import pymel.core as pm
from alShaders import alShadersTemplate

class AEalHairTemplate(alShadersTemplate):
	def setup(self):
		self.addSwatch()
		self.beginScrollLayout()

		self.beginLayout("Matte")
		self.addControl("aiEnableMatte", label="Enable Matte")
		self.addControl("aiMatteColor", label="Matte Color")
		self.addControl("aiMatteColorA", label="Matte Opacity")
		self.endLayout()
		self.beginLayout("Fibre properties", collapse=False)
		self.addControl("hairColor", label="Color")
		self.addControl("specularWidth", label="Highlight width")
		self.addControl("specularShift", label="Highlight shift")
		self.addControl("opacity", label="opacity")
		self.beginLayout("Randomize", collapse=True)
		self.addControl("randomTangent", label="Tangent")
		self.addControl("randomHue", label="Hue")
		self.addControl("randomSaturation", label="Saturation")
		self.endLayout() # END Randomize
		self.beginLayout("Advanced", collapse=True)
		self.addControl("glintRolloff", label="Glint rolloff")
		self.addControl("transmissionRolloff", label="Transmission rolloff")
		self.addControl("singleSaturation", label="Highlight saturation")
		self.addControl("multipleSaturation", label="Diffuse saturation")
		self.endLayout() # END Advanced
		self.endLayout() # END Fibre properties
		self.beginLayout("Diffuse", collapse=False)
		self.addControl("diffuseStrength", label="Strength")
		self.addControl("diffuseColor", label="Tint")
		self.addControl("diffuseForward", label="Forward scattering")
		self.addControl("diffuseBack", label="Back scattering")
		self.endLayout() # END Diffuse
		self.beginLayout("Specular 1", collapse=False)
		self.addControl("specular1Strength", label="Strength")
		self.addControl("specular1Color", label="Tint")
		self.addControl("specular1WidthScale", label="Width scale")
		self.addControl("specular1Shift", label="Shift")
		self.endLayout() # END Specular 1
		self.beginLayout("Specular 2", collapse=False)
		self.addControl("specular2Strength", label="Strength")
		self.addControl("specular2Color", label="Tint")
		self.addControl("specular2WidthScale", label="Width scale")
		self.addControl("specular2Shift", label="Shift")
		self.beginLayout("Glints", collapse=False)
		self.addControl("glintStrength", label="Strength")
		self.addControl("glintTexture", label="Texture")
		self.addControl("twist", label="Twist")
		self.endLayout() # END Glints
		self.endLayout() # END Specular 2
		self.beginLayout("Transmission", collapse=False)
		self.addControl("transmissionStrength", label="Strength")
		self.addControl("transmissionColor", label="Tint")
		self.addControl("transmissionWidthScale", label="Width scale")
		self.addControl("transmissionShift", label="Shift")
		self.endLayout() # END Transmission
		self.beginLayout("IDs", collapse=True)
		self.addControl("id1", label="id1")
		self.addControl("id2", label="id2")
		self.addControl("id3", label="id3")
		self.addControl("id4", label="id4")
		self.addControl("id5", label="id5")
		self.addControl("id6", label="id6")
		self.addControl("id7", label="id7")
		self.addControl("id8", label="id8")
		self.endLayout() # END IDs
		self.beginLayout("AOVs", collapse=True)
		self.addControl("aov_diffuse_color", label="Diffuse color")
		self.addControl("aov_direct_diffuse", label="Direct diffuse")
		self.addControl("aov_indirect_diffuse", label="Indirect diffuse")
		self.addControl("aov_direct_local", label="Direct local")
		self.addControl("aov_indirect_local", label="Indirect local")
		self.addControl("aov_direct_global", label="Direct global")
		self.addControl("aov_indirect_global", label="Indirect global")
		self.addControl("aov_direct_specular", label="Direct specular")
		self.addControl("aov_indirect_specular", label="Indirect specular")
		self.addControl("aov_direct_specular_2", label="Direct specular 2")
		self.addControl("aov_indirect_specular_2", label="Indirect specular 2")
		self.addControl("aov_direct_transmission", label="Direct transmission")
		self.addControl("aov_indirect_transmission", label="Indirect transmission")
		self.addControl("aov_light_group_1", label="Light group [1]")
		self.addControl("aov_light_group_2", label="Light group [2]")
		self.addControl("aov_light_group_3", label="Light group [3]")
		self.addControl("aov_light_group_4", label="Light group [4]")
		self.addControl("aov_light_group_5", label="Light group [5]")
		self.addControl("aov_light_group_6", label="Light group [6]")
		self.addControl("aov_light_group_7", label="Light group [7]")
		self.addControl("aov_light_group_8", label="Light group [8]")
		self.addControl("aov_id_1", label="ID [1]")
		self.addControl("aov_id_2", label="ID [2]")
		self.addControl("aov_id_3", label="ID [3]")
		self.addControl("aov_id_4", label="ID [4]")
		self.addControl("aov_id_5", label="ID [5]")
		self.addControl("aov_id_6", label="ID [6]")
		self.addControl("aov_id_7", label="ID [7]")
		self.addControl("aov_id_8", label="ID [8]")
		self.endLayout() # END AOVs
		self.beginLayout("Advanced", collapse=True)
		self.addControl("MIS", label="MIS")
		self.addControl("dualDepth", label="Brute force bounces")
		self.addControl("diffuseIndirectStrength", label="Diffuse indirect strength")
		self.addControl("extraSamplesDiffuse", label="Diffuse extra samples")
		self.addControl("glossyIndirectStrength", label="Glossy indirect strength")
		self.addControl("extraSamplesGlossy", label="Glossy extra samples")
		self.addControl("uparam", label="U param")
		self.addControl("vparam", label="V param")
		self.endLayout() # END Advanced

		pm.mel.AEdependNodeTemplate(self.nodeName)
		self.addExtraControls()

		self.endScrollLayout()
